unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, MPlayer, StdCtrls, ExtCtrls, ComCtrls, Menus;

type
  TForm1 = class(TForm)
    MediaPlayer1: TMediaPlayer;
    GroupBox1: TGroupBox;
    Otvori: TButton;
    Izlaz: TButton;
    CBPonavljaj: TCheckBox;
    ListaPesama: TListBox;
    OpenDialog1: TOpenDialog;
    Start: TButton;
    Pauza: TButton;
    Stop: TButton;
    Sledeca: TButton;
    TrackBar1: TTrackBar;
    TimerPoz: TTimer;
    TimerPromene: TTimer;
    TimerTekuca: TTimer;
    PMListe: TPopupMenu;
    SnimiListu: TMenuItem;
    SaveDialog1: TSaveDialog;
    ObrisiIme: TMenuItem;
    procedure OtvoriClick(Sender: TObject);
    procedure IzlazClick(Sender: TObject);
    procedure NotifyProc(Sender: TObject);
    procedure StartClick(Sender: TObject);
    procedure PauzaClick(Sender: TObject);
    procedure StopClick(Sender: TObject);
    procedure Lista;
    procedure SledecaClick(Sender: TObject);
    procedure TimerPozTimer(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure ListaPesamaDblClick(Sender: TObject);
    procedure ListaPesamaKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TimerPromeneTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TimerTekucaTimer(Sender: TObject);
    procedure ListaPesamaClick(Sender: TObject);
    procedure SnimiListuClick(Sender: TObject);
    procedure ObrisiImeClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Plejlista: TStringList;
  tekuca: integer = -1;

implementation

{$R *.dfm}

procedure TForm1.NotifyProc(Sender: TObject);
const
  ModeStr: array[TMPModes] of string = ('Nije spreman', 'Stop', 'Svira', 'Snima', 'Seeking', 'Pauza', 'Otvara');
  NotifiS: array[TMPNotifyValues] of string = ('Successful', 'Superseded', 'Aborted', 'Failure');
begin
   with Sender as TMediaPlayer do
   begin
     Form1.Caption := 'Muzika - '+ ModeStr[Mode];
     if NotifyValue <> nvSuccessful then
      Form1.Caption := Form1.Caption+' '+NotifiS[NotifyValue];
     case Mode of
       mpStopped: begin
        if TimerPoz.Enabled then begin
         Close;
         Lista;
         Play;
        end;
       end;
       mpPlaying: begin
         if Position = Length then
          Stop;
        TimerPoz.Enabled := true;
       end;
     end;
     Notify := True;
   end;
end;

procedure TForm1.OtvoriClick(Sender: TObject);
 var lup: integer;
begin
 if OpenDialog1.Execute then begin
  if UpperCase(ExtractFileExt(OpenDialog1.FileName)) = '.M3U' then begin
   ListaPesama.Items.LoadFromFile(OpenDialog1.FileName);
   Plejlista.Clear;
   tekuca := -1;
   if MediaPlayer1.Mode in [MPlayer.mpOpen, MPlayer.mpPaused, MPlayer.mpPlaying] then begin
    MediaPlayer1.Stop;
    MediaPlayer1.Position := 0;
   end;
   for lup := 0 to ListaPesama.Items.Count-1 do
    Plejlista.Add(ExtractFilePath(OpenDialog1.FileName)+
     ListaPesama.Items.Strings[lup]);
   //mp3...
   //tag- 0-128
   //ime pesme - 0-30
   //izvodjac - 31-60
   //album naziv - 61-90
   //godina - 91-94
   //komentar - 95-128

  end else
  if OpenDialog1.Files.Count > 1 then begin
   Plejlista.Assign(OpenDialog1.Files);
   ListaPesama.Items.Clear;
   tekuca := -1;
   if MediaPlayer1.Mode in [MPlayer.mpOpen, MPlayer.mpPaused, MPlayer.mpPlaying] then begin
    MediaPlayer1.Stop;
    MediaPlayer1.Position := 0;
   end;
   for lup := 0 to Plejlista.Count-1 do
    ListaPesama.Items.Strings[lup] := ExtractFileName(Plejlista.Strings[lup]);
  end else begin
   ListaPesama.Items.Add(ExtractFileName(OpenDialog1.FileName));
   Plejlista.Add(OpenDialog1.FileName);
  end;

  Start.Enabled:= true;
  Pauza.Enabled:= true;
  Stop.Enabled:= true;
  Sledeca.Enabled:= true;
 end;
end;

procedure TForm1.IzlazClick(Sender: TObject);
begin
 Close;
end;

procedure TForm1.StartClick(Sender: TObject);
begin
 MediaPlayer1.Notify := true;
 if (tekuca > -1)and(tekuca < ListaPesama.Count) then begin
  if not ListaPesama.Selected[tekuca] then begin
   tekuca := 0;
   while tekuca < ListaPesama.Count-1 do begin
    if ListaPesama.Selected[tekuca] then
     break;
    inc(tekuca);
   end;
   if not ListaPesama.Selected[tekuca] then
    tekuca := 0;
  end;
  ListaPesama.Selected[tekuca] := true;
  ListaPesama.SetFocus;
  MediaPlayer1.FileName:= Plejlista.Strings[tekuca];
 end else
  Lista;

 if MediaPlayer1.Mode <> MPlayer.mpOpen then MediaPlayer1.Open;
 MediaPlayer1.Play;
end;

procedure TForm1.PauzaClick(Sender: TObject);
begin
 MediaPlayer1.Pause;
end;

procedure TForm1.StopClick(Sender: TObject);
begin
 TimerPoz.Enabled := false;
 if MediaPlayer1.Mode in [MPlayer.mpOpen, MPlayer.mpPaused, MPlayer.mpPlaying] then begin
  MediaPlayer1.Stop;
  MediaPlayer1.Position := 0;
 end;
end;

procedure TForm1.Lista;
begin
 if (not CBPonavljaj.Checked) or (tekuca = -1) then begin
  Inc(tekuca);
  if tekuca = ListaPesama.Items.Count then tekuca := 0;
 end;

 ListaPesama.Selected[tekuca] := true;
 ListaPesama.SetFocus;
 if MediaPlayer1.Mode = mpPlaying then Stop.Click;
 MediaPlayer1.FileName:= Plejlista.Strings[tekuca];
 if MediaPlayer1.Mode <> MPlayer.mpOpen then MediaPlayer1.Open;
end;

procedure TForm1.SledecaClick(Sender: TObject);
begin
 Lista;
 Start.Click;
end;

procedure TForm1.TimerPozTimer(Sender: TObject);
begin
 if TimerPromene.Enabled then exit;
 if MediaPlayer1.Mode <> mpPlaying then exit;
 TrackBar1.OnChange := nil;
 TrackBar1.Position := MediaPlayer1.Position div (MediaPlayer1.Length div 100);
 TrackBar1.OnChange := TrackBar1Change;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
 if MediaPlayer1.Mode <> mpPlaying then exit;
 TimerPromene.Enabled := false;
 TimerPromene.Enabled := true;
end;

procedure TForm1.ListaPesamaDblClick(Sender: TObject);
begin
 if Start.Enabled then Start.Click;
end;

procedure TForm1.ListaPesamaKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if Key = VK_RETURN then begin
  if Start.Enabled then
   Start.Click;
 end else
  TimerTekuca.Enabled := true;  
end;

procedure TForm1.TimerPromeneTimer(Sender: TObject);
 var pozn: integer;
begin
 TimerPromene.Enabled := false;
 pozn := TrackBar1.Position * (MediaPlayer1.Length div 100);
 if MediaPlayer1.Position <> pozn then begin
  MediaPlayer1.Stop;
  MediaPlayer1.Position := pozn;
  MediaPlayer1.Play;
 end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 MediaPlayer1.Notify := True;
 Plejlista := TStringList.Create;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 Plejlista.Free;
 MediaPlayer1.Notify := false;
 if MediaPlayer1.Mode in [MPlayer.mpOpen, MPlayer.mpPaused, MPlayer.mpPlaying] then
  MediaPlayer1.Stop;
end;

procedure TForm1.TimerTekucaTimer(Sender: TObject);
begin
 if (tekuca > -1)and(tekuca < ListaPesama.Count) then
  if not ListaPesama.Selected[tekuca] then begin
   ListaPesama.Selected[tekuca] := true;
   ListaPesama.SetFocus;
  end;
 TimerTekuca.Enabled := false;
end;

procedure TForm1.ListaPesamaClick(Sender: TObject);
begin
 TimerTekuca.Enabled := true;
end;

procedure TForm1.SnimiListuClick(Sender: TObject);
begin
 SaveDialog1.InitialDir := OpenDialog1.InitialDir;
 SaveDialog1.FileName := 'lista.m3u';
 if SaveDialog1.Execute then
  ListaPesama.Items.SaveToFile(SaveDialog1.FileName);
end;

procedure TForm1.ObrisiImeClick(Sender: TObject);
begin
  if ListaPesama.Count = 0 then exit;
  if not ((tekuca > -1)and(tekuca < ListaPesama.Count)) then
   tekuca := 0;
  Stop.Click;

  if not ListaPesama.Selected[tekuca] then begin
   tekuca := 0;
   while tekuca < ListaPesama.Count-1 do begin
    if ListaPesama.Selected[tekuca] then
     break;
    inc(tekuca);
   end;
   if not ListaPesama.Selected[tekuca] then
    tekuca := 0;
  end;
  ListaPesama.Selected[tekuca] := true;
  if ListaPesama.Selected[tekuca] then begin
   ListaPesama.DeleteSelected;
   Plejlista.Delete(tekuca);
   if ListaPesama.Count = 0 then
    tekuca := -1
   else
   if tekuca >= ListaPesama.Count then begin
    tekuca := 0;
    ListaPesama.Selected[tekuca] := true;
   end;
  end;
  ListaPesama.SetFocus;
end;

end.
